<template>

  <v-container
    class="d-flex flex-wrap"
    id="formulary-page"
  >
    <!-- Register new person section-->
    <page
      class="flex-grow-1"
      id="create_person"
      title="Nova Pessoa"
    >
      <formulary
        :success-msg="(model) => `${model.fullname} created successfuly`"
        submit-label="Enviar"
        :submit="submit"
        :template="template"
      ><template v-slot="{ model, loading }">
          <v-subheader>Dados Pessoais</v-subheader>
          <v-text-field
            outlined="outlined"
            autocomplete="off"
            v-model="model.fullname"
            :disabled="loading"
            :rules="[vRequired('Nome')]"
            label="Nome Completo *"
           />          <date-input
            outlined="outlined"
            autocomplete="off"
            v-model="model.birthDate"
            :disabled="loading"
            :rules="[vDate('Data inválida')]"
            label="Data de Nascimento *"
           />          <v-text-field
            outlined="outlined"
            disabled="disabled"
            autocomplete="off"
            placeholder="Preencha a data de nascimento"
            :value="model.birthDate && ISOtoAge(model.birthDate)"
            label="Idade"
           />          <biological-sex-input
            outlined="outlined"
            autocomplete="off"
            v-model="model.sex"
            :disabled="loading"
            :rules="[vRequired('Sexo biológico')]"
            label="Sexo Biológico *"
           />          <civil-status-input
            outlined="outlined"
            autocomplete="off"
            v-model="model.civilStatus"
            :disabled="loading"
            :rules="[vRequired('Estado civil')]"
            label="Estado Civil *"
           />          <v-subheader>Documento</v-subheader>
          <document-input
            outlined="outlined"
            autocomplete="off"
            v-model="model.document"
            :disabled="loading"
           />          <v-subheader>Endereço</v-subheader>
          <address-input
            outlined="outlined"
            autocomplete="off"
            v-model="model.address"
            :disabled="loading"
           />          <v-subheader>Contato</v-subheader>
          <contact-input
            outlined="outlined"
            autocomplete="off"
            v-model="model.contact"
            :disabled="loading"
           />          <v-subheader>Outros</v-subheader>
          <marketing-media-input
            outlined="outlined"
            v-model="model.marketingMedia"
            :disabled="loading"
            :rules="[vRequired('Meio de divulgação')]"
            label="Meio de divulgação*"
           />          <v-checkbox
            outlined="outlined"
            v-model="model.imagePermission"
            :disabled="loading"
            label="Permissão de uso de imagem"
           />          <v-textarea
            outlined="outlined"
            label="Observações"
            :disabled="loading"
            v-model="model.observations"
           />        </template></formulary>
    </page>
    <!-- Person List Section-->
    <persons-page />
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue'

import vRequired from '@/validators/required'
import vDate from '@/validators/date'

import Page from '@/components/Page.vue'
import Formulary from '@/components/Formulary.vue'

import PersonsPage from './Persons.vue'
import { ISOtoAge } from '@/util/dates'

// Types
import { IAddress } from '@/types/Address'
import { IContact } from '@/types/Contact'

// Queries
import createPersonMutation from '@/gql/PersonCreate.gql'

// Inputs
import DocumentInput from '@/components/input/Document.vue'
import DateInput from '@/components/input/Date.vue'
import AddressInput from '@/components/input/Address.vue'
import BiologicalSexInput from '@/components/input/BiologicalSex.vue'
import CivilStatusInput from '@/components/input/CivilStatus.vue'
import ContactInput from '@/components/input/Contact.vue'
import MarketingMediaInput from '@/components/input/MarketingMedia.vue'

export default Vue.extend({
  name: 'FormularyPage',
  components: {
    Page,
    Formulary,

    DocumentInput,
    DateInput,
    AddressInput,
    BiologicalSexInput,
    CivilStatusInput,
    ContactInput,
    MarketingMediaInput,

    PersonsPage
  },
  data: () => ({
    last: null,
    code: null,

    template: () => ({
      fullname: '',
      birthDate: null as string | null,
      sex: null as string | null,
      civilStatus: null as string | null,
      document: null as {
        type: string,
        value: string
      } | null,
      address: null as IAddress | null,
      contact: null as IContact | null,
      marketingMedia: null as string | null,
      observations: null as string | null,
      imagePermission: false as boolean
    }),

    vRequired,
    vDate
  }),
  methods: {
    ISOtoAge,
    async submit (model: IContact) {
      const answer = await this.$apollo.mutate({
        mutation: createPersonMutation,
        variables: {
          data: model
        }
      })
      this.last = answer.data.person
    }
  }
})
</script>
